drm/panthor: Don't add write fences to the shared BOs
[drm/drm-misc.git] / scripts / syscalltbl.sh
blob6a903b87a7c210c966a021ccd2fb816b17f21727
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0-only
4 # Generate a syscall table header.
6 # Each line of the syscall table should have the following format:
8 # NR ABI NAME [NATIVE] [COMPAT]
10 # NR syscall number
11 # ABI ABI name
12 # NAME syscall name
13 # NATIVE native entry point (optional)
14 # COMPAT compat entry point (optional)
16 set -e
18 usage() {
19 echo >&2 "usage: $0 [--abis ABIS] INFILE OUTFILE" >&2
20 echo >&2
21 echo >&2 " INFILE input syscall table"
22 echo >&2 " OUTFILE output header file"
23 echo >&2
24 echo >&2 "options:"
25 echo >&2 " --abis ABIS ABI(s) to handle (By default, all lines are handled)"
26 exit 1
29 # default unless specified by options
30 abis=
32 while [ $# -gt 0 ]
34 case $1 in
35 --abis)
36 abis=$(echo "($2)" | tr ',' '|')
37 shift 2;;
38 -*)
39 echo "$1: unknown option" >&2
40 usage;;
42 break;;
43 esac
44 done
46 if [ $# -ne 2 ]; then
47 usage
50 infile="$1"
51 outfile="$2"
53 nxt=0
55 grep -E "^[0-9]+[[:space:]]+$abis" "$infile" | {
57 while read nr abi name native compat noreturn; do
59 if [ $nxt -gt $nr ]; then
60 echo "error: $infile: syscall table is not sorted or duplicates the same syscall number" >&2
61 exit 1
64 while [ $nxt -lt $nr ]; do
65 echo "__SYSCALL($nxt, sys_ni_syscall)"
66 nxt=$((nxt + 1))
67 done
69 if [ "$compat" = "-" ]; then
70 unset compat
73 if [ -n "$noreturn" ]; then
74 if [ "$noreturn" != "noreturn" ]; then
75 echo "error: $infile: invalid string \"$noreturn\" in 'noreturn' column"
76 exit 1
78 if [ -n "$compat" ]; then
79 echo "__SYSCALL_COMPAT_NORETURN($nr, $native, $compat)"
80 else
81 echo "__SYSCALL_NORETURN($nr, $native)"
83 elif [ -n "$compat" ]; then
84 echo "__SYSCALL_WITH_COMPAT($nr, $native, $compat)"
85 elif [ -n "$native" ]; then
86 echo "__SYSCALL($nr, $native)"
87 else
88 echo "__SYSCALL($nr, sys_ni_syscall)"
90 nxt=$((nr + 1))
91 done
92 } > "$outfile"